﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;

namespace MessageReminder
{
    public partial class SettingsForm : Form
    {
        public SettingsForm()
        {
            InitializeComponent();
        }

        private void SettingsForm_Load(object sender, EventArgs e)
        {
            txtUrl.Text = (Owner as Form1).m_Url;
            txtUrl.SelectionLength = 0;
            txtUrl.SelectionStart = 0;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            //读取程序集的配置文件
            string assemblyConfigFile = Assembly.GetEntryAssembly().Location;
            Configuration config = ConfigurationManager.OpenExeConfiguration(assemblyConfigFile);
            //获取appSettings节点
            AppSettingsSection appSettings = (AppSettingsSection)config.GetSection("appSettings");
            //删除url，然后添加新值
            appSettings.Settings.Remove("url");
            appSettings.Settings.Add("url", txtUrl.Text.Trim());
            (Owner as Form1).m_Url = txtUrl.Text.Trim();
            (Owner as Form1).m_DesktopMsgService.Url = (Owner as Form1).m_Url + "/WebService/DesktopMsgService/Service.asmx";
            //保存配置文件
            config.Save();
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
